unit UApoyo;

interface
uses
  Windows,SysUtils, Variants, Classes, Graphics, math;

const
  _Lamb = 255;

type
  Mat3d  = record
    nc,nr  : integer;
    dat    : array of array of array of single;
  end;

  procedure BM2Mat(BM : TBitMap; var Mat : Mat3d  );
  procedure Mat2BM(Mat: Mat3d  ; var BM  : TBitMap);

  function aj256(u : single):byte;
  function aj512(u : single):integer;

  procedure SetMat(var Mat : Mat3d; col,ren,can : integer);
  procedure Mat2Mat(Ma : Mat3d; var Mb : Mat3d);

var
  _x1, _y1, _x2, _y2  : integer;  

implementation

// justa un real pequeo a byte
function aj256(u : single):byte;
begin
  if u > _Lamb
    then result := _Lamb
    else if u<0
      then Result := 0
      else Result := ceil(u);
end;

// justa un real pequeo a byte + 1 bit
function aj512(u : single):integer;
begin
  if u > 512
    then result := 511
    else if u<0
      then Result := 0
      else Result := ceil(u);
end;

// define tamao para matriz de imagen
procedure SetMat(var Mat : Mat3d; col,ren,can : integer);
begin
  Mat.nc := col;
  Mat.nr := ren;
  SetLength(Mat.dat,col,ren,can);
end;

// copia Ma en Mb siempre que Ma no este vacia
procedure Mat2Mat(Ma : Mat3d; var Mb : Mat3d);
var
  x,y,can : integer;
begin
  if (Ma.nc*Ma.nr <> 0) then begin
    SetMat(Mb,Ma.nc,Ma.nr,3);
    for y := 0 to Ma.nr - 1 do
      for x := 0 to Ma.nc - 1 do
        for can := 0 to 2 do
          Mb.dat[x][y][can] := Ma.dat[x][y][can];
  end;
end;

// Bitmap a Matriz de tres canales
procedure BM2Mat(BM : TBitMap; var Mat : Mat3d  );
var
  x,y,pix : integer;
begin
  Mat.nc := BM.Width;
  Mat.nr := BM.Height;
  SetLength(Mat.dat,Mat.nc,Mat.nr,3);

  for y := 0 to Mat.nr - 1 do
    for x := 0 to Mat.nc - 1 do begin
      pix := BM.Canvas.Pixels[x,y];
      Mat.dat[x][y][0] := GetRValue(pix);
      Mat.dat[x][y][1] := GetGValue(pix);
      Mat.dat[x][y][2] := GetBValue(pix);
    end;
end;

// Matriz en BitMap
procedure Mat2BM(Mat: Mat3d  ; var BM  : TBitMap);
var
  x,y,pix,r,g,b : integer;
begin
  BM.Width  := Mat.nc;
  BM.Height := Mat.nr;

  for y := 0 to Mat.nr - 1 do
    for x := 0 to Mat.nc - 1 do begin
      r := aj256(Mat.dat[x][y][0]);
      g := aj256(Mat.dat[x][y][1]);
      b := aj256(Mat.dat[x][y][2]);

      pix := RGB(r,g,b);
      BM.Canvas.Pixels[x,y] := pix;
    end;
end;

end.
